using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_AddingColumns
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        private System.Windows.Forms.Button button3;
        private GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{			
			GridEngineFactory.Factory = new GroupingEngineFactory();
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button3 = new System.Windows.Forms.Button();
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // button3
            // 
            this.button3.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.button3.Location = new System.Drawing.Point(323, -188);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(240, 24);
            this.button3.TabIndex = 3;
            this.button3.Text = "Add Column";
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Location = new System.Drawing.Point(12, 14);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.Size = new System.Drawing.Size(674, 400);
            this.gridGroupingControl1.TabIndex = 4;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            this.gridGroupingControl1.VersionInfo = "4.202.0.37";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(698, 426);
            this.Controls.Add(this.gridGroupingControl1);
            this.Controls.Add(this.button3);
            this.Name = "Form1";
            this.Text = "GGC_AddingColumns...";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private int numberParentRows = 10;
		private int numberChildRows = 10;

		# region DataTables

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("Lines");
			
			dt.Columns.Add(new DataColumn("TitleName",typeof(string))); //lower case p
			dt.Columns.Add(new DataColumn("Airs",typeof(string)));
			dt.Columns.Add(new DataColumn("Length",typeof(int)));
			dt.Columns.Add(new DataColumn("CurrentRate",typeof(double)));
			dt.Columns.Add(new DataColumn("RevenueTypeID",typeof(int)));
			dt.Columns.Add(new DataColumn("InventoryTypeID",typeof(string)));
			dt.Columns.Add(new DataColumn("TotalSpot",typeof(int)));
			dt.Columns.Add(new DataColumn("TotalDollar",typeof(double)));

			for(int i = 1; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = string.Format("TitleName{0}",i);
				dr[1] = string.Format("Airs{0}",i);
				dr[2] = i * i * 30;
				dr[3] = i * i * 30 * 40;
				dr[4] = i;
				dr[5] = string.Format("TypeID{0}",i);
				dr[6] = 15 * i;
				dr[7] = i * i * 30 * 40 + 1000 * 15 * i;
				dt.Rows.Add(dr); 
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("RevenueTypeID",typeof(int))); //upper case P
			
            //Random r = new Random(); 
            //for(int i = 1; i < numberChildRows; ++i)
            //{
            //    DataRow dr = dt.NewRow();
            //    dr[0] = i.ToString();
            //    dr[1] = string.Format("ChildName{0}",i);
            //    dr[2] = r.Next(numberParentRows);
            //    dt.Rows.Add(dr);
            //}
		
			return dt;
		}

		# endregion

		DataSet ds;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();

			ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable});

            //setup the relations
            //DataColumn parentColumn = parentTable.Columns["RevenueTypeID"];
            //DataColumn childColumn = childTable.Columns["RevenueTypeID"];
            //ds.Relations.Add("ParentToChild", ds.Tables[0].Columns["RevenueTypeID"], ds.Tables[1].Columns["RevenueTypeID"]);

            //set the master-detail-detail grids
            this.gridGroupingControl1.DataSource = parentTable; // parentTable; //master
           // this.gridGroupingControl1.TableDescriptor.Relations.Clear(); // don't autopopulate relations

            //this.gridGroupingControl2.DataSource = childTable; //detail1
            //this.gridGroupingControl2.DataMember = "ParentToChild"; //detail1
            //this.gridGroupingControl2.TableDescriptor.Relations.Clear(); // don't autopopulate relations            		
            new OrderForm(this.gridGroupingControl1);
		}
		
		int c = 1;
		private void button3_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.TableControl.BeginUpdate();			
			foreach(DataTable dt in ds.Tables)
			{
				dt.Columns.Add(new DataColumn("Test"+c.ToString()));
				for(int i = 0; i < dt.Rows.Count; ++i)
					dt.Rows[i][dt.Columns.Count-1] = "Hello!";
				dt.AcceptChanges(); 
				ds.AcceptChanges();
			}
			this.gridGroupingControl1.TableControl.EndUpdate(true);
			this.gridGroupingControl1.TableDescriptor.ResetVisibleColumns();
			c++;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{			
//			this.gridGroupingControl1.TableDescriptor.ResetSummaries();
//			this.gridGroupingControl1.TableDescriptor.ResetVisibleColumns();
//			this.gridGroupingControl1.TableDescriptor.ResetSummaryRows();
//			this.gridGroupingControl1.TableDescriptor.ResetExpressionFields();
//			this.gridGroupingControl1.TableDescriptor.ResetGroupedColumns();
			this.gridGroupingControl1.ResetTableDescriptor();
//			this.gridGroupingControl1.ResetTableOptions(); 
			this.gridGroupingControl1.DataSource = null;
			this.gridGroupingControl1.DataSource = GetChildTable();
		}

        private void splitterControl1_Click(object sender, EventArgs e)
        {

        }
	}
}
