using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_AddingColumns
{
	public class OrderForm
	{
		GridGroupingControl gridGroupingControl1;
		public OrderForm(GridGroupingControl grid)
		{
			this.gridGroupingControl1 = grid;
			// GroupingEngineFactory provides a modified GridChildTable that adds an extra section
			//GridEngineFactory.Factory = new GroupingEngineFactory();
			//InitializeComponent();
			//InitializeDataSet();
			OptimizeGrid(this.gridGroupingControl1);
			InitializeLineGrid();
		}


		private void InitializeLineGrid()
		{      

			//this.gridGroupingControl1.QueryCustomSummary += new GridQueryCustomSummaryEventHandler(gridGroupingControl1_QueryCustomSummary);
//			this.gridGroupingControl1.DataSource = dsOrder.Tables["Lines"];

			// Force filling and intialization of engine and drawing of grid.
			int count = this.gridGroupingControl1.Table.DisplayElements.Count;

			#region Setting Expression Columns
//			string PivotWeekColumns = string.Empty;
//			string TotalSpotExpression = string.Empty;
//			foreach (KeyValuePair<string, List<SellingPeriodWeek>> kvp in SellingPeriods)
//																						{
//																							foreach (SellingPeriodWeek spw in kvp.Value)
//																							{
//																								PivotWeekColumns += string.Format("[{0}],", spw.WeekID.ToString(Literal.WEEKID_FORMAT_STRING));
//																							}
//																						}
//
//			PivotWeekColumns = PivotWeekColumns.TrimEnd(new char[] { ',' });
//			string TotalSpotExpressionXXX = String.Format("{0}", String.Join("+", PivotWeekColumns.Split(new char[] { ',' })));

//			TotalSpotExpression = String.Format("({0})", String.Join("+", PivotWeekColumns.Split(new char[] { ',' })));
//			string TotalSpotExpressionXXX = "[Length] *2";
//
//			ExpressionFieldDescriptor TotalSpotColumn = new ExpressionFieldDescriptor("TotalSpot", TotalSpotExpressionXXX, typeof(double));
//			ExpressionFieldDescriptor TotalEQ30Column = new ExpressionFieldDescriptor("TotalEQ30", "(([Length]/30)) * [TotalSpot]", typeof(double));
//			ExpressionFieldDescriptor TotalDollarColumn = new ExpressionFieldDescriptor("TotalDollar", "([CurrentRate] * [TotalSpot])", typeof(double));
//
//			this.gridGroupingControl1.TableDescriptor.ExpressionFields.Add(TotalSpotColumn);
//			this.gridGroupingControl1.TableDescriptor.ExpressionFields.Add(TotalEQ30Column);
//			this.gridGroupingControl1.TableDescriptor.ExpressionFields.Add(TotalDollarColumn);
			#endregion

			#region [ Add SellingTitle Section Visible Columns...]
			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Clear();
			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("TitleName");
			this.gridGroupingControl1.TableDescriptor.Columns["TitleName"].Appearance.AnyRecordFieldCell.CellType = "Static";
			this.gridGroupingControl1.TableDescriptor.Columns["TitleName"].Appearance.AnyRecordFieldCell.BackColor = Color.AliceBlue;
			this.gridGroupingControl1.TableDescriptor.Columns["TitleName"].Appearance.AnyRecordFieldCell.Trimming = StringTrimming.EllipsisCharacter;
			this.gridGroupingControl1.TableDescriptor.Columns["TitleName"].Width = 140;
			this.gridGroupingControl1.TableDescriptor.Columns["TitleName"].HeaderText = "SellingTitle Name";

			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("Airs");
			this.gridGroupingControl1.TableDescriptor.Columns["Airs"].Appearance.AnyRecordFieldCell.CellType = "Static";
			this.gridGroupingControl1.TableDescriptor.Columns["Airs"].Appearance.AnyRecordFieldCell.BackColor =Color.AliceBlue;
			this.gridGroupingControl1.TableDescriptor.Columns["Airs"].Appearance.AnyRecordFieldCell.Trimming = StringTrimming.EllipsisCharacter;
			this.gridGroupingControl1.TableDescriptor.Columns["Airs"].Width = 70;
			this.gridGroupingControl1.TableDescriptor.Columns["Airs"].HeaderText = "Day Times";

			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("Length");
			this.gridGroupingControl1.TableDescriptor.Columns["Length"].Appearance.AnyRecordFieldCell.CellType = "TextBox";
			this.gridGroupingControl1.TableDescriptor.Columns["Length"].Width = 50;
			this.gridGroupingControl1.TableDescriptor.Columns["Length"].HeaderText = "Len";

			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("CurrentRate");
			this.gridGroupingControl1.TableDescriptor.Columns["CurrentRate"].Appearance.AnyRecordFieldCell.CellType = "TextBox";
			this.gridGroupingControl1.TableDescriptor.Columns["CurrentRate"].Appearance.AnyRecordFieldCell.Format = "$#,##0.00;($#,##0.00);$0.00";
			this.gridGroupingControl1.TableDescriptor.Columns["CurrentRate"].Width = 75;
			this.gridGroupingControl1.TableDescriptor.Columns["CurrentRate"].HeaderText = "Rate";

			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("RevenueTypeID");
			this.gridGroupingControl1.TableDescriptor.Columns["RevenueTypeID"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
			this.gridGroupingControl1.TableDescriptor.Columns["RevenueTypeID"].AllowDropDownCell = true;
			this.gridGroupingControl1.TableDescriptor.Columns["RevenueTypeID"].Appearance.AnyRecordFieldCell.DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.Exclusive;
			this.gridGroupingControl1.TableDescriptor.Columns["RevenueTypeID"].Appearance.AnyRecordFieldCell.DataSource = GetComboTable();
			this.gridGroupingControl1.TableDescriptor.Columns["RevenueTypeID"].Appearance.AnyRecordFieldCell.DisplayMember = "ValueMember";
			this.gridGroupingControl1.TableDescriptor.Columns["RevenueTypeID"].Appearance.AnyRecordFieldCell.ValueMember = "DisplayMember";
			this.gridGroupingControl1.TableDescriptor.Columns["RevenueTypeID"].Width = 60;
			this.gridGroupingControl1.TableDescriptor.Columns["RevenueTypeID"].HeaderText = "Revenue";

			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("InventoryTypeID");
			this.gridGroupingControl1.TableDescriptor.Columns["InventoryTypeID"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
			this.gridGroupingControl1.TableDescriptor.Columns["InventoryTypeID"].AllowDropDownCell = true;
			this.gridGroupingControl1.TableDescriptor.Columns["InventoryTypeID"].Appearance.AnyRecordFieldCell.DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.Exclusive;
			this.gridGroupingControl1.TableDescriptor.Columns["InventoryTypeID"].Appearance.AnyRecordFieldCell.DataSource = GetComboTable();
			this.gridGroupingControl1.TableDescriptor.Columns["InventoryTypeID"].Appearance.AnyRecordFieldCell.DisplayMember = "DisplayMember";
			this.gridGroupingControl1.TableDescriptor.Columns["InventoryTypeID"].Appearance.AnyRecordFieldCell.ValueMember = "ValueMember";
			this.gridGroupingControl1.TableDescriptor.Columns["InventoryTypeID"].Width = 100;
			this.gridGroupingControl1.TableDescriptor.Columns["InventoryTypeID"].HeaderText = "Inventory Type";
			#endregion

			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("TotalSpot");
			this.gridGroupingControl1.TableDescriptor.Columns["TotalSpot"].Appearance.AnyRecordFieldCell.CellType = "Static";
			this.gridGroupingControl1.TableDescriptor.Columns["TotalSpot"].Appearance.AnyRecordFieldCell.BackColor = Color.AliceBlue;
			this.gridGroupingControl1.TableDescriptor.Columns["TotalSpot"].Width = 55;
			this.gridGroupingControl1.TableDescriptor.Columns["TotalSpot"].HeaderText = "Spot";

			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Add("TotalDollar");
			this.gridGroupingControl1.TableDescriptor.Columns["TotalDollar"].Appearance.AnyRecordFieldCell.CellType = "Static";
			this.gridGroupingControl1.TableDescriptor.Columns["TotalDollar"].Appearance.AnyRecordFieldCell.BackColor = Color.AliceBlue;
			this.gridGroupingControl1.TableDescriptor.Columns["TotalDollar"].Appearance.AnyRecordFieldCell.Format = "$#,##0;($#,##0);$0";
			this.gridGroupingControl1.TableDescriptor.Columns["TotalDollar"].Width = 65;
			this.gridGroupingControl1.TableDescriptor.Columns["TotalDollar"].HeaderText = "Dollar";		
	
			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Reset(); 

            //#region [ Add Summmary Columns...]
            //// add blank summary row, customize as header
            //this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(new GridSummaryRowDescriptor("Empty"));

            //// Define a summary row and mark it visible.
            //int SummaryColumnCount = this.gridGroupingControl1.TableDescriptor.Columns.Count;
            //// In that summary row add columns and set it's mapping name (and DisplayColumn) ; names must be unique
            //GridSummaryColumnDescriptor[] SpotSummaryColumns = new GridSummaryColumnDescriptor[SummaryColumnCount];
            //GridSummaryColumnDescriptor[] DollarSummaryColumns = new GridSummaryColumnDescriptor[SummaryColumnCount];
            //GridSummaryColumnDescriptor[] ImpressionSummaryColumns = new GridSummaryColumnDescriptor[SummaryColumnCount];
            //GridSummaryColumnDescriptor[] DollarsPercentSummaryColumns = new GridSummaryColumnDescriptor[SummaryColumnCount];
            //GridSummaryRowDescriptor rowDescriptor;

            //int idx = 0;
            //foreach (GridVisibleColumnDescriptor map in this.gridGroupingControl1.TableDescriptor.VisibleColumns )
            //{
            //  // GridColumnDescriptor desc;				
            //    //if (map.IsSummaryColumn)
            //    {
            //        string columnName = map.Name;
            //        SpotSummaryColumns[idx] = new GridSummaryColumnDescriptor(string.Format("_Spot_{0}", columnName), SummaryType.DoubleAggregate, columnName, "{Sum:#,###;(#,###);0}");
            //        SpotSummaryColumns[idx].IgnoreRecordFilterCriteria = true;		

            //        DollarSummaryColumns[idx] = new GridSummaryColumnDescriptor(string.Format("_Dollar_{0}", columnName), SummaryType.Custom, columnName, "{Total:$#,###;($#,###.00);$0}");
            //        DollarSummaryColumns[idx].IgnoreRecordFilterCriteria = true;

            //        System.Diagnostics.Debug.WriteLine(string.Format("_PercentDollar_{0}", columnName) + " = " + columnName);
            //        DollarsPercentSummaryColumns[idx] = new GridSummaryColumnDescriptor(string.Format("_PercentDollar_{0}", columnName), SummaryType.Custom, columnName, "{Total:#,###;(#,###);0}");
            //        DollarsPercentSummaryColumns[idx].IgnoreRecordFilterCriteria = true;
            //        idx++;
            //    }
            //}

            ////summary row -> spots
            //rowDescriptor = new GridSummaryRowDescriptor("SpotSummaryRow", SpotSummaryColumns);
            //this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(rowDescriptor);

            ////summary row -> dollars
            //rowDescriptor = new GridSummaryRowDescriptor("DollarSummaryRow", DollarSummaryColumns);
            //this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(rowDescriptor);

            //// add blank summary row, customize as header
            ////this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(new GridSummaryRowDescriptor("Empty"));
            ////rowIndexCoveredHeader = ++rowIndex;

            //#endregion

			#region [ Initialize Grid Appearance Settings ... ]

			// select * cell text when focus set
			this.gridGroupingControl1.TableControl.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.SelectAll;

			// empty summary 
			this.gridGroupingControl1.Appearance.SummaryEmptyCell.HorizontalAlignment = GridHorizontalAlignment.Center;
			this.gridGroupingControl1.Appearance.SummaryEmptyCell.Borders.All = new GridBorder(GridBorderStyle.Standard);

			//summary field
			this.gridGroupingControl1.Appearance.AnySummaryCell.Borders.All = new GridBorder(GridBorderStyle.Standard);
			this.gridGroupingControl1.Appearance.SummaryFieldCell.HorizontalAlignment = GridHorizontalAlignment.Center;

			// Here you define the summary row that should be used for displaying summaries in caption bar.
			this.gridGroupingControl1.TableDescriptor.ChildGroupOptions.ShowCaptionSummaryCells = true;

			// Let's you hide/show the second row in child groups.
			this.gridGroupingControl1.TableDescriptor.ChildGroupOptions.ShowSummaries = false;

			//For MainTable GroupCaption..
			this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;

			// Can't add rows
			this.gridGroupingControl1.TableDescriptor.ChildGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridGroupingControl1.TableDescriptor.ChildGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridGroupingControl1.TableDescriptor.ChildGroupOptions.ShowSummaries = false;
			this.gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = false;
			this.gridGroupingControl1.TableOptions.ShowRowHeader = false;

			// set GroupCaption appearance
			this.gridGroupingControl1.Appearance.GroupCaptionSummaryCell.HorizontalAlignment = GridHorizontalAlignment.Center;
			this.gridGroupingControl1.Appearance.GroupCaptionCell.HorizontalAlignment = GridHorizontalAlignment.Left;
			//this.gridGroupingControl1.TableDescriptor.Appearance.GroupCaptionCell.CellType = "EmptyCell";
			this.gridGroupingControl1.Appearance.GroupCaptionCell.BackColor = this.gridGroupingControl1.Appearance.RecordFieldCell.BackColor;
			this.gridGroupingControl1.Appearance.GroupCaptionCell.Borders.Top = new GridBorder(GridBorderStyle.Standard);
			this.gridGroupingControl1.Appearance.GroupCaptionCell.CellType = "Static";
			this.gridGroupingControl1.Appearance.GroupCaptionCell.Enabled = false;

			// set caption and header row height
			this.gridGroupingControl1.TableOptions.CaptionRowHeight = this.gridGroupingControl1.TableOptions.RecordRowHeight;
			this.gridGroupingControl1.TableOptions.ColumnHeaderRowHeight = this.gridGroupingControl1.TableOptions.RecordRowHeight;

			// header
			this.gridGroupingControl1.Appearance.ColumnHeaderCell.BaseStyle = "HeaderStyle";
			this.gridGroupingControl1.TableModel.Cols.FrozenCount = 2;

			// group by this field
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("TitleName", ListSortDirection.Ascending);

			// sort by
			//this.gridGroupingControl1.TableDescriptor.SortedColumns.AddRange(new Syncfusion.Grouping.SortColumnDescriptor[] {
			//                                                                                                                    new Syncfusion.Grouping.SortColumnDescriptor("CompanyName", System.ComponentModel.ListSortDirection.Descending)});

			// expand all groups by default
			this.gridGroupingControl1.Table.ExpandAllGroups();
            
			#endregion

			#region [ Grid Events Hookup ... ]

//			this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
//			this.gridGroupingControl1.QueryCoveredRange += new GridTableQueryCoveredRangeEventHandler(gridGroupingControl1_QueryCoveredRange);
			this.gridGroupingControl1.CurrentRecordContextChange += new CurrentRecordContextChangeEventHandler(gridGroupingControl1_CurrentRecordContextChange);
//			this.gridGroupingControl1.TableControl.ResizingColumns += new GridResizingColumnsEventHandler(TableControl_ResizingColumns);
//
//			this.gridGroupingControl1.TableControlCurrentCellActivated += new GridTableControlEventHandler(gridGroupingControl1_TableControlCurrentCellActivated);
//
//			// FIX - > Enable LEFT/RIGHT arrow movement across caption row
//			this.gridGroupingControl1.TableControlCurrentCellKeyDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridGroupingControl1_TableControlCurrentCellKeyDown);
//
//			//FIX  1 of 2 and 2 0f 2 below-> Prevent focus on CaptionSection from expanding row
//			this.gridGroupingControl1.TableControlCellButtonClicked +=new GridTableControlCellButtonClickedEventHandler(gridGroupingControl1_TableControlCellButtonClicked);
//			this.gridGroupingControl1.GroupExpanding +=new GroupEventHandler(gridGroupingControl1_GroupExpanding);
			this.gridGroupingControl1.TableControlKeyDown += new GridTableControlKeyEventHandler(gridGroupingControl1_TableControlKeyDown);
			#endregion
		}

		private void OptimizeGrid(GridGroupingControl grid)
		{
			// Use less memory for internal binary tree structures
			//grid.CounterLogic = EngineCounters.YAmount;
            //grid.AllowedOptimizations = EngineOptimizations.DisableCounters | EngineOptimizations.RecordsAsDisplayElements;
            //grid.TableOptions.VerticalPixelScroll = false;
            //grid.TableOptions.ColumnsMaxLengthStrategy = GridColumnsMaxLengthStrategy.FirstNRecords;
            //grid.TableOptions.ColumnsMaxLengthFirstNRecords = 100;
            ////grid.TableOptions.GridLineBorder = new GridBorder(GridBorderStyle.Solid, Color.WhiteSmoke);

            //// Update display with changes, optionally use ScrollWindow for insert and removing rows.
            //grid.UpdateDisplayFrequency = 1;  // immediate update after each ListChanged.
            //grid.InsertRemoveBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate;  // Scrollwindow will cause immediate update.
            //grid.SortPositionChangedBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate;  // Scrollwindow will cause immediate update.

			if (typeof(object).AssemblyQualifiedName.IndexOf("Version=1") == -1)
			{
				// .NET 2.0 gets very slow when subscribing to ListChanged event on the 
				// DataTable.DefaultView. The following setting allows the engine to wrap 
				// datatable with a Syncfusion.Collections.DataTableList to work around 
				// this bottleneck.
				//
				// .NET 1.0 and 1.1 are just fine with using DataTable.DefaultView
				//
				grid.AllowSwapDataViewWithDataTableList = true;
			}
		}

		DataTable GetComboTable()
		{
			DataTable dt = new DataTable();
			dt.Columns.Add("DisplayMember"); 
			dt.Columns.Add("ValueMember");			

			dt.Rows.Add(new object[] {"One","1"}); 
			dt.Rows.Add(new object[] {"Two","2"});
			dt.Rows.Add(new object[] {"Three","3"});
			dt.Rows.Add(new object[] {"Four","4"});
			dt.Rows.Add(new object[] {"Five","5"});

			return dt;
		}

		void gridGroupingControl1_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
		{
			if (e.Action == CurrentRecordAction.CurrentFieldChanged)
			{
				this.gridGroupingControl1.CurrencyManager.EndCurrentEdit();
				this.gridGroupingControl1.Table.InvalidateSummary();
			}
		}

        private void gridGroupingControl1_TableControlKeyDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventArgs e)
        {
            GridCurrentCell cc = this.gridGroupingControl1.TableControl.CurrentCell;
            if (e.Inner.KeyCode == Keys.Right)
            {                
                CaptionRow cs = this.gridGroupingControl1.Table.TableModel.GetDisplayElementAt(cc.RowIndex) as CaptionRow;
                if (cs != null && cs.GroupLevel > 0)
                {
                    Group g = cs.ParentGroup;
                    if (g.IsExpanded)
                    {
                        g.IsExpanded = !g.IsExpanded;
                        this.gridGroupingControl1.TableControl.CurrentCell.MoveTo(cc.RowIndex, cc.ColIndex + 1);
                        e.Inner.Handled = true;
                    }
                }
            }
            if (e.Inner.KeyCode == Keys.Left)
            {               
                if (this.gridGroupingControl1.Table.TableModel.GetDisplayElementAt(cc.RowIndex + 1) is CaptionRow)
                {
                    this.gridGroupingControl1.TableControl.CurrentCell.MoveTo(cc.RowIndex, cc.ColIndex - 1);
                    e.Inner.Handled = true;
                }
            }
        }
	}
}
